// bits.cc
// Darstellung der Bit-Codierung der verschiedenen elementaren Datentypen
// stark abhaengig von der Rechnerarchitektur!!

#include <iostream.h>

template <class T>
ostream& bits(ostream &os, const T& x) {
  char *p = (char *) &x;        // Wandle Adresse von x in char-Adresse
  int   k = sizeof(x);
  k = (k==12)?k-2:k;   // Fuer long double werden nur 10 Byte verwendet !
  // Die letzte Zeile sollte bei allgemeinerer Verwendung auskommentiert werden
  for (int i = k-1; i >= 0; i--) {      // Durchlaufen der Bytes von x
    for (int c = 128; c > 0; c >>= 1)   // ein Byte bitweise ausgeben
      os << ( p[i] & c ? 1 : 0 ); 
    os << " ";                          // Trennung der Bytes
  }
  return os << "\n";
}

int main() {
  char c;int i; long long ll;
  float f; double d; long double ld;
  // Ausgabe der Groessen
  cout << "sizeof(char)        =  " << sizeof(char)        << "\n";
  cout << "sizeof(int)         =  " << sizeof(int)         << "\n";
  cout << "sizeof(long long)   =  " << sizeof(long long)   << "\n";
  cout << "sizeof(float)       =  " << sizeof(float)       << "\n";
  cout << "sizeof(double)      =  " << sizeof(double)      << "\n";
  cout << "sizeof(long double) = " << sizeof(long double)  << "\n";
  while (1) {
    cout << " : "; cin >> ld; 
    // Umwandlung per cast
    c  = (char) ld; i = (int) ld; ll = (long long) ld; 
    f = (float) ld; d = (double) ld;
    // Ausgabe:
    bits(cout,c); bits(cout,i); bits(cout,ll);
    bits(cout,f); bits(cout,d); bits(cout,ld);
  }
}         
